/*
Name: 			Pages / Timeline - Examples
Written by: 	usp.br/nds
*/

(function( $ ) {

	'use strict';

	var initLightbox = function() {
		$('.timeline .thumbnail-gallery').magnificPopup({
			delegate: 'a',
			type: 'image',
			tLoading: 'Carregando imagem #%curr%...',
			mainClass: 'mfp-img-mobile',
			gallery: {
				enabled: true,
				navigateByImgClick: true,
				preload: [0,1] // Will preload 0 - before current, and 1 after the current image
			},
			image: {
				tError: '<a href="%url%">A imagem #%curr%</a> nao pode ser carregada.'
			}
		});
	};

	var initGoogleMaps = function() {
		var map = new GMaps({
			div: '#gmap-checkin-example',
			lat: -23.33305494,
			lng: -46.60490513,
			markers: [{
				lat: -23.33305494,
				lng: -46.60490513,
				infoWindow: {
					content: '<p>Mairipora - Minha Casa</p>'
				}
			}],
			scrollwheel: false
		});

		map.addMarker({
			lat: -23.33305494,
			lng: -46.60490513,
			infoWindow: {
				content: '<p>Mairipora - Minha Casa</p>'
			}
		});
	};

	$(function() {
		initLightbox();
		initGoogleMaps();
	});

}).apply(this, [ jQuery ]);